// SPDX-License-Identifier: Unlicense

import QtQuick 2.12
import QtQuick.Controls 2.13

// Define and display a shortcut to focus the given control.
Label {
    required property Item control
    property alias sequence: shortcut.sequence

    text: shortcut.nativeText
    visible: !control.activeFocus

    color: 'gray'
    padding: 1
    leftPadding: 2*padding
    rightPadding: 2*padding

    background: Rectangle {
        color: palette.base
        border { color: Qt.lighter(parent.color); width: 1 }
        opacity: 0.9
        radius: 2
    }

    Shortcut {
        id: shortcut
        onActivated: control.forceActiveFocus()
    }
}
